#define ARRAY_SIZE 200
char a[ARRAY_SIZE];
/* char b[ARRAY_SIZE]; */

void reverse1()
{
  int i, n;
  char tmp;
  
  n= ARRAY_SIZE;
  i= 0;
  /** {\forall i. 0\leq i< n --> a[i]= b[i] } */
  while (i< n/2) {
    /** { \forall j. 0\leq j< i --> a[j]= b[n-1-j] && 
          \forall j. n-1-i< j<n --> a[j]= b[n-1-j] && 
          \forall j. i\leq j \leq n-1-i --> a[j]= b[j] &&
          i < n/2 } */
    
    /** { \forall j. 0\leq j< i+1 --> (j == i ? a[n-1-i] : (j == n-1-i ? a[i] : a[j]))= b[n-1-j] && 
          \forall j. n-1-(i+1)< j<n --> (j == i ? a[n-1-i] : (j == n-1-i ? a[i] : a[j])) == b[n-1-j] && 
          \forall j. i+1\leq j \leq n-1-(i+1) --> a[j]= b[j] } */
    tmp= a[n-1-i];
    /** { \forall j. 0\leq j< i+1 --> (j == i ? tmp : (j == n-1-i ? a[i] : a[j]))= b[n-1-j] && 
          \forall j. n-1-(i+1)< j<n --> (j == i ? tmp : (j == n-1-i ? a[i] : a[j])) == b[n-1-j] && 
          \forall j. i+1\leq j \leq n-1-(i+1) --> a[j]= b[j] } */
    a[n-1-i]= a[i];
    /** { \forall j. 0\leq j< i+1 --> (j == i ? tmp : a[j]) == b[n-1-j] && 
          \forall j. n-1-(i+1)< j<n --> (j == i ? tmp : a[j]) == b[n-1-j] && 
          \forall j. i+1\leq j \leq n-1-(i+1) --> a[j]= b[j] } */
    a[i]= tmp;
    /** { \forall j. 0\leq j< i+1 --> a[j]= b[n-1-j] && 
          \forall j. n-1-(i+1)< j<n --> a[j]= b[n-1-j] && 
          \forall j. i+1\leq j \leq n-1-(i+1) --> a[j]= b[j] } */
    i= i+1;
    /** { \forall j. 0\leq j< i --> a[j]= b[n-1-j] && 
          \forall j. n-1-i< j<n --> a[j]= b[n-1-j] && 
          \forall j. i\leq j \leq n-1-i --> a[j]= b[j] } */
  }
  /** { \forall j. 0\leq j< n --> a[i]= b[n-1-i] } */
}  



VC:

1. (Inv)
   --> \forall j. 0\leq j< i+1 --> (j == i ? a[n-1-i] : (j == n-1-i ? a[i] : a[j]))= b[n-1-j]
  --> (\forall j. 0\leq j< i --> (j == i ? a[n-1-i] : (j == n-1-i ? a[i] : a[j]))= b[n-1-j]) && (i == i ? a[n-1-j] : (i == n-1-i ? a[i] : a[i]))= b[n-1-i]
  
    j<i, i< n/2 ==> 2i< n ==> i<n-i, hence j != n-1-i
  
  --> (\forall j. 0<leq j<i --> a[j] == b[n-1-j]) && a[n-1-i] ==  b[n-1-i]
  (1) ist (Inv (1))
  (2) folgt aus (Inv (3))

2. (Inv)
   --> \forall j. n-1-(i+1)< j<n --> (j == i ? a[n-1-i] : (j == n-1-i ? a[i] : a[j])) == b[n-1-j] 
  --> \forall j. n-i< j<n --> (j == i ? a[n-1-i] : (j == n-1-i ? a[i] : a[j])) == b[n-1-j]
  -->  ((n-i-1 == i ? a[n-1-i] : (n-1-i == n-1-i ? a[i] : a[n-i-1])) == b[n-1-(n-1-i)]) && 
  (\forall j. n-1-i< j<n --> (j == i ? a[n-1-i] : (j == n-1-i ? a[i] : a[j])) == b[n-1-j])
   --> a[i] == b[n-1-n+1+i] && ...
   --> a[i] == b[i] && ...

  (1) folgt aus (Inv (3)), (2) ist (Inv (2))

3. (Inv)
   -->  \forall j. i+1\leq j \leq n-1-(i+1) --> a[j] == b[j]

  folgt aus Inv(3): \forall j. i\leq j\leq n-1-i. a[j] == b[j]
  i<i+1, n-i> n-1-i
