
#define ARRAY_SIZE 200
int a[ARRAY_SIZE];

void reverse2()
{
  int i, n, tmp;

  n= ARRAY_SIZE;
  i= 0;
  /** { bs= seq(a, n) } */
  while (i< n/2) {
    /** { as= seq(a,n) -->
          rev(as[n-i:n])++ as[i:n-i]++ rev(as[0:i])== bs } */
    /** { as= upd(upd(seq(a, n), n-i-1, a[i]), i, a[n-i-1]) -->
          rev(as[n-(i+1):n])++ as[i+1:n-(i+1)]++ rev(as[0:i+1])== bs } */
    tmp= a[n-1-i];
    /** { as= upd(upd(seq(a, n), n-i-1, a[i]), i, tmp) -->
          rev(as[n-(i+1):n])++ as[i+1:n-(i+1)]++ rev(as[0:i+1])== bs } */
    a[n-i-1]= a[i];
    /** { as= upd(seq(a, n),i,tmp) -->
          rev(as[n-(i+1):n])++ as[i+1:n-(i+1)]++ rev(as[0:i+1])== bs } */
    a[i]= tmp;
    /** { as= seq(a,n) -->
          rev(as[n-(i+1):n])++ as[i+1:n-(i+1)]++ rev(as[0:i+1])== bs } */
    i= i+1;
    /** { as= seq(a,n) -->
          rev(as[n-i:n])++ as[i:n-i]++ rev(as[0:i])== bs } */
  }
  /** { as= seq(a,n) --> rev(as)== bs } */ 
}

/*
Def. let switch(a, i, j) := upd(upd(a, i, a[j]), j, a[i])
*/

/* Proof: */
/** { as= upd(upd(seq(a, n), n-i-1, a[i]), i, a[n-i-1]) -->
      rev(as[n-(i+1):n])++ as[i+1:n-(i+1)]++ rev(as[0:i+1])== bs } */
/** { as= switch(seq(a, n), n-i-1, i) -->
      rev(as[n-1-i:n])++ as[i+1:n-(i+1)]++ rev(as[0:i+1]) == bs } */
/** { as = switch(seq(a, n), n-i-1, i) -->
      rev(as[n-i:n]) ++ [as[n-i-1]] ++ as[i+1:n-(i+1)] ++ [as[i]]++ rev(as[0:i]) == bs } */
/** { as0 = seq(a, n) && as = switch(as0, n-i-1, i) -->
      rev(as0[n-i:n])++ as0[i] ++ as0[i+1:n-1-i]++ as0[n-1-i]++ rev(as0[0:i]) == bs } */
/** { as0 = seq(a, n) && as = switch(as0, n-i-1, i) -->
      rev(as0[n-i:n])++ [as0[i]] ++ as0[i+1:n-1-i]++ as0[n-1-i]++ rev(as0[0:i]) == bs } */
/** { as0 = seq(a, n) -->
      rev(as0[n-i:n])++ as0[i:n-1-i]++ as0[n-1-i]++ rev(as0[0:i]) == bs } */
/** { as0 = seq(a, n) -->
      rev(as0[n-i:n])++ as0[i:n-i]++ rev(as0[0:i]) == bs } */

/*
Lemmas:
  rev(a++b)   == rev(b) ++ rev(a)
  rev([])     == []
  rev([b])    == [b]

  rev(a++[b]) == [b] ++ rev(a)
  rev([a]++b) == rev(b])++ [a]

  a[i:j+1]    == a[i:j] ++ [a[j]]
  a[i-1:j]    == [a[i-1]] ++ a[i:j]

  i, j <m --> switch(a, i, j)[m:n] == a[m:n]
  n< i, j --> switch(a, i, j)[m:n] == a[m:n]			      
i<n, m< j --> switch(a, i, j)[m:n] == a[m:n]			      

  i< m     --> set(a, i, v)[m:n] == a[m:n]
  n<= i    --> set(a, i, v)[m:n] == a[m:n]
  m<= i< n --> set(a, i, v)[m:n] == set(a[m:n], i-m, v)
*/
